/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.filters.Convolution;

import javax.swing.DefaultComboBoxModel;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import static org.visnow.vn.lib.basic.filters.Convolution.ConvolutionShared.*;
import org.visnow.jvia.spatialops.Padding.PaddingType;

/**
 *
 * @author Michal Lyczek (lyczek@icm.edu.pl)
 */
public class GUI extends javax.swing.JPanel
{

    private Parameters parameters;

    /**
     * Creates new form ConvolutionPanel
     */
    public GUI()
    {
        initComponents();
        cbPadding.setModel(new DefaultComboBoxModel(PaddingType.values()));
    }

    void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    void updateGUI(ParameterProxy p)
    {
        cbPadding.setSelectedItem(p.get(PADDING_TYPE));
        normalizeCheckBox.setSelected(p.get(NORMALIZE_KERNEL));
        componentList.setListData(p.get(META_COMPONENT_NAMES));
        componentList.setSelectedIndices(p.get(SELECTED_COMPONENTS));
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel3 = new javax.swing.JLabel();
        componentList = new javax.swing.JList();
        jLabel1 = new javax.swing.JLabel();
        cbPadding = new javax.swing.JComboBox();
        normalizeCheckBox = new javax.swing.JCheckBox();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));

        setMinimumSize(new java.awt.Dimension(164, 92));
        setLayout(new java.awt.GridBagLayout());

        jLabel3.setText("Components:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(jLabel3, gridBagConstraints);

        componentList.setBorder(javax.swing.BorderFactory.createLineBorder(javax.swing.UIManager.getDefaults().getColor("Button.darkShadow")));
        componentList.addListSelectionListener(new javax.swing.event.ListSelectionListener()
        {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt)
            {
                componentListValueChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(componentList, gridBagConstraints);

        jLabel1.setText("Padding:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(jLabel1, gridBagConstraints);

        cbPadding.setName("cbPadding"); // NOI18N
        cbPadding.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                cbPaddingActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(cbPadding, gridBagConstraints);

        normalizeCheckBox.setSelected(true);
        normalizeCheckBox.setText("Normalize kernel");
        normalizeCheckBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                normalizeCheckBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        add(normalizeCheckBox, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.weighty = 1.0;
        add(filler1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void componentListValueChanged(javax.swing.event.ListSelectionEvent evt)//GEN-FIRST:event_componentListValueChanged
    {//GEN-HEADEREND:event_componentListValueChanged
        if (!evt.getValueIsAdjusting())
            parameters.set(SELECTED_COMPONENTS, componentList.getSelectedIndices());
    }//GEN-LAST:event_componentListValueChanged

    private void normalizeCheckBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_normalizeCheckBoxActionPerformed
    {//GEN-HEADEREND:event_normalizeCheckBoxActionPerformed
        parameters.set(NORMALIZE_KERNEL, normalizeCheckBox.isSelected());
    }//GEN-LAST:event_normalizeCheckBoxActionPerformed

    private void cbPaddingActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_cbPaddingActionPerformed
    {//GEN-HEADEREND:event_cbPaddingActionPerformed
        parameters.set(PADDING_TYPE, (PaddingType) cbPadding.getSelectedItem());
    }//GEN-LAST:event_cbPaddingActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox cbPadding;
    private javax.swing.JList componentList;
    private javax.swing.Box.Filler filler1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JCheckBox normalizeCheckBox;
    // End of variables declaration//GEN-END:variables

//    public void setInFieldData(RegularField field)
//    {
//        dataComponentList.setScalarComponentsOnly(true);
//        dataComponentList.setInField(field);
//    }
}
